apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ template "wallet.fullname" . }}
  labels: {{ include "wallet.labels" $ | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ template "wallet.fullname" . }}
      app.kubernetes.io/instance: {{ .Release.Name }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ template "wallet.fullname" . }}
        app.kubernetes.io/instance: {{ .Release.Name }}
      annotations:
        checksum/config: {{ tpl (toYaml .Values.config) . | sha256sum }}
    spec:
      containers:
        - name: wallet
          image: "{{ .Values.image }}"
          imagePullPolicy: Always
          {{- with concat .Values.env (fromYamlArray (list .Values.configFromSecrets "" | include "recurseSecretConfig"))}}
          env: {{ toYaml . | nindent 12 }}
          {{- end }}
          resources:
            requests:
              memory: "100Mi"
          ports:
            - name: http
              containerPort: {{ .Values.config.server.port | default 3000 }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /health
              port: {{ .Values.config.server.port | default 3000 }}
          readinessProbe:
            httpGet:
              path: /health
              port: {{ .Values.config.server.port | default 3000 }}
          volumeMounts:
          - name: wallet-config
            mountPath: /app/config.yaml
            subPath: "config.yaml"
      volumes:
      - name: wallet-config
        configMap:
          name: {{ template "wallet.fullname" . }}-config
